﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using foxit;
using foxit.pdf;
using foxit.common.fxcrt;
using foxit.pdf.interform;
using System.Drawing;
using System.Windows.Threading;

namespace PDFReader_Demo_CSharp.UI
{
    public class FormFillerAssist : FillerAssistCallback
    {
        protected CPDFReaderDoc reader_doc_;
        private System.Windows.Threading.DispatcherTimer timer_ = new DispatcherTimer();
        public FormFillerAssist(CPDFReaderDoc reader_doc)
        {
            reader_doc_ = reader_doc;
        }

        public override void Dispose()
        {
            base.Dispose();
        }

        public override void FocusGotOnControl(Control control, string value)
        {

        }

        public override void FocusLostFromControl(Control control, string value)
        {

        }

        public override int GetVersion()
        {
            return 1;
        }

        public override bool KillTimer(int timer_id)
        {
            if(timer_id == 1)
                timer_.Stop();
            return true;
        }

        public override void Refresh(PDFPage page, RectF rect)
        {
            MainForm main_form = reader_doc_.GetView();
            if (main_form == null)
                return;
            main_form.ReDraw();
        }

        public override void Release()
        {
            timer_.Stop();
            MainForm main_form = reader_doc_.GetView();
            if (main_form != null)
            {
                main_form.SetTimeCallback(null);
            }
           
        }

        void Timer_Tick(object sender, EventArgs e)
        {
            MainForm main_form = reader_doc_.GetView();
            if (main_form == null)
                return ;
            if(main_form.GetTimeCallback()!=null)
                main_form.GetTimeCallback().OnTimer(1);
        }

        public override bool SetTimerCallback(int elapse, TimerCallback timer, out int out_timer_id)
        {
            MainForm main_form = reader_doc_.GetView();
            if (main_form == null)
            {
                out_timer_id = -1;
                return false;
            }
            main_form.SetTimeCallback(timer);
            out_timer_id = 1;
            timer_.Interval = new System.TimeSpan(0,0,0,0,elapse);
            timer_.Tick += new EventHandler(Timer_Tick);
            timer_.Start();
            return true;
        }
    }
}
